<?php defined('SYSPATH') || die('No direct script access.');

class Model_Helper_Builder extends Model
{
    protected $data;

    private static $create_new = '__CREATE__!@#$%^&;';

    function __construct() {
        // Variable, allows to create new instance in db
        $this->data = [self::$create_new => true];
    }

    /**
     * @param array $map
     * @return $this
     * @throws InvalidArgumentException
     */
    public function fromSet(array $map) {
        foreach ($map as $name => $value) {
            if ($name === '__construct' || $name === 'fromSet' || $name === 'create')
                throw new InvalidArgumentException("`$name` field is incorrect");
            if (method_exists($this, $name))
                $this->{$name}($value);
        }

        return $this;
    }
}