<?php defined('SYSPATH') || die('No direct script access.');

/**
 * Class Model_Semesters
 *
 * @property int ID
 * @property int Num
 * @property int Year
 * @property string Season
 */
class Model_Statistics extends Model
{
    public static function requests($startDate, $endDate) {
        $query = 'CALL `Stats_GetSupportRequestFrequency`(:startDate, :endDate)';
        $stats = DB::query(Database::SELECT, $query)
            ->param(':startDate', $startDate)
            ->param(':endDate', $endDate)
            ->execute()->as_array();
        return $stats;
    }

    public static function log_ins($startDate, $endDate) {
        $query = 'CALL `Stats_GetSignInFrequency`(:startDate, :endDate)';
        $stats = DB::query(Database::SELECT, $query)
            ->param(':startDate', $startDate)
            ->param(':endDate', $endDate)
            ->execute()->as_array();
        return $stats;
    }

}
